#----------------------------------------------------------------------------bh-
# This RPM .spec file is part of the OpenHPC project.
#
# It may have been modified from the default version supplied by the underlying
# release package (if available) in order to apply patches, perform customized
# build/install configurations, and supply additional files to support
# desired integration conventions.
#
#----------------------------------------------------------------------------eh-

# Build f90 modules for newer gcc variants for use with Intel MPI
%define ohpc_compiler_dependent 1
%define ohpc_mpi_dependent 1
%define mpi_family impi
%include %{_sourcedir}/OHPC_macros


# Base package name
%define pname impi-f90-modules
%define PNAME %(echo %{pname} | tr [a-z] [A-Z])

Name:           %{pname}-%{compiler_family}%{PROJ_DELIM}
Summary:        Intel MPI bindings for GCC 8
License:        Intel Simplified Software License (Version January 2018)
Group:          %{PROJ_NAME}/parallel-libs
Version:        1.0
Release:        14.1.ohpc.1.3.6
Source0:        intel-mpi-binding-kit.tar.gz
Requires:       lmod%{PROJ_DELIM} >= 7.6.1

BuildRequires:  intel-mpi-devel-ohpc

#!BuildIgnore: post-build-checks

%define psxe_version 2018.3.222

# Default library install path
Prefix: /opt/intel 
%define install_path /opt/intel/compilers_and_libraries_%{psxe_version}/linux/mpi/include64/gfortran/8.2.0

%description
Intel MPI bindings for GCC 8


%prep
%setup -q -n f90


%build
# OpenHPC compiler/mpi designation
%ohpc_setup_compiler

export MPI_INST=${I_MPI_ROOT}
export F90=gfortran
make

%install
mkdir -p %{buildroot}%install_path
cp intel64/include/pgf/* %{buildroot}%install_path

%post
. /etc/profile.d/lmod.sh
module purge
module load gnu8
module load impi
file=`which mpif90`

if [ -z "$file" ];then
	echo "Unable to find mpif90"
    exit 1
fi

if ! grep -q "OpenHPC" $file ; then
    if [ -s $file ];then
	lineno=`grep -n 'gver="/7.1.0"' $file | tail -1 | cut -d : -f 1`
	if [ $lineno -gt 0 ];then
	        %{__cat} <<EOF > add.txt
        # OpenHPC - add definition for gcc 8.2.0
        8 )
            case "$mid" in
                1 )
                    gver="/8.2.0"
                    ;;
                * )
                    gver="/8.2.0"
                    ;;
            esac
            ;;
EOF
		let modline=`expr $lineno+3`
		if [ $modline -gt 0 ];then
		    echo "Updating $file..."
		    %{__sed} -i "$modline r add.txt" $file
	        fi
	fi
    fi
fi

%files
%{install_path}
